use crate::utils::input_reader;

pub fn part_one() -> String {
    if let Ok(lines) = input_reader::read_lines("./input/2023/day_01/input.txt") {
        let mut result = 0;

        for line in lines {
            result += parse_line(&line.unwrap());
        }

        result.to_string()
    } else {
        panic!("Failed to read lines from input file");
    }
}

fn parse_line(s: &str) -> u32 {
    const RADIX: u32 = 10;

    let mut first_digit = 0;
    let mut last_digit = 0;

    for c in s.chars() {
        if c.is_digit(RADIX) {
            let digit = c.to_digit(RADIX).unwrap();

            if first_digit == 0 {
                first_digit = digit;
            }
            last_digit = digit;
        }
    }

    return first_digit * 10 + last_digit;
}
