use crate::utils::input_reader;

pub fn part_two() -> String {
    if let Ok(lines) = input_reader::read_lines("./input/2023/day_06/input.txt") {
        let mut race_result: Vec<u64> = Vec::new();

        for line in lines {
            race_result.push(process_line(&line.unwrap()));
        }

        let win_count = process_race_result(race_result[0], race_result[1]);

        win_count.to_string()
    } else {
        panic!("Failed to read lines from input file");
    }
}

fn process_line(s: &str) -> u64 {
    let nums_str = s.split(':').collect::<Vec<&str>>()[1]
        .split_whitespace()
        .collect::<Vec<&str>>()
        .concat();
    let num: u64 = nums_str.parse::<u64>().unwrap();

    return num;
}

fn process_race_result(time: u64, distance: u64) -> u64 {
    let mut win_count = 0;

    for i in 0..time {
        if i * (time - i) > distance {
            win_count += 1;
        }
    }

    return win_count;
}
