use super::common::{parse_line, get_differences, all_zeros};

pub fn part_two(input_lines: Vec<String>) -> String {
    let mut result: i32 = 0;

    for line in input_lines {
        let nums = parse_line(&line);

        let mut first: Vec<i32> = Vec::new();
        first.push(nums.first().unwrap().clone());

        let mut diffs = get_differences(nums.clone());
        first.push(diffs.first().unwrap().clone());

        while !all_zeros(diffs.clone()) {
            diffs = get_differences(diffs.clone());
            first.push(diffs.first().unwrap().clone());
        }

        first.reverse();

        let mut res = 0;        
        res = first.iter().fold(res, |acc, &x| x - acc);

        result += res;
    }

    result.to_string()
}