use super::common::Rock;

pub fn part_one(input_lines: Vec<String>) -> String {

    let mut platform: Vec<Vec<Rock>> = Vec::new();

    for line in input_lines {
        let mut row: Vec<Rock> = Vec::new();
        for c in line.chars() {
            match c {
                '.' => row.push(Rock::N),
                '#' => row.push(Rock::S),
                'O' => row.push(Rock::R),
                _ => panic!("Invalid character: {}", c),
            }
        }

        platform.push(row);
    }

    tilt(&mut platform);

    let result = count_load(&platform);
    result.to_string()

    // String::from("Not implemented")
}

fn tilt(platform : &mut Vec<Vec<Rock>>) {
    for i in 0..platform.len() {
        for j in 0..platform[i].len() {
            if platform[i][j] == Rock::R {
                let mut k = i;
                while k >= 1 && platform[k - 1][j] == Rock::N {
                    k -= 1;
                }
                platform[i][j] = Rock::N;
                platform[k][j] = Rock::R;                    
            }
        }
    }
}

fn count_load(platform : &Vec<Vec<Rock>>) -> usize {
    let mut count = 0;
    for i in 0..platform.len() {
        for j in 0..platform[i].len() {
            if platform[i][j] == Rock::R {
                count += platform.len() - i;
            }
        }
    }
    count
}